# ifndef CWRITE_DATASYSTEM_H
   # define CWRITE_DATASYSTEM_H

   # define TYPE_MODE    0x01
   # define INS_MODE     0x02
   # define MODIFY_STATE 0x04
   # define DETACH_STATE 0x08
   # define SCROLL_STATE 0x10
   
   # define DATASYSTEM_CARDINAL  10
   # define DATASYSTEM_SELECTION  0
   # define DATASYSTEM_FIRST      1
   # define DATASYSTEM_LAST  (DATASYSTEM_CARDINAL - 1)
   
   # include "bookmark.h"
   # include "datachains.h"

   struct Datasystem
      { Datachain * _datachain_first;
        Datachain * _datachain;
        Datachain * _datachain_last;
        char * _filename;
        bool read_only;
        int ordinal;
        int dataline_max_size;
        int dataline_offset;
        int cursor_y;
        int cursor_x;
        int status_register;
        Datachain * _datachain_detach_start;
        Datachain * _datachain_detach_end;
        int cursor_y_detach;
        Bookmark bookmark[BOOKMARK_CARDINAL];
        int bookmark_ordinal;
      };
    
   extern Datasystem * _datasystem;

   extern Datasystem * _datasystem_pointer[];
   extern int datasystem_ordinal_main;

      // -- datasystem control --
   extern int datasystem_count;
   extern int datasystem_ordinal;
   extern int datasystem_filename_memsize;

      // -- pointers to current datasystem --
   extern Datachain ** __datachain_first;
   extern Datachain ** __datachain;
   extern Datachain ** __datachain_last;
   extern char ** __filename;
   extern int * _dataline_offset;
   extern int * _cursor_y;
   extern int * _cursor_x;
   extern int * _status_register;
   extern Datachain ** __datachain_detach_start;
   extern Datachain ** __datachain_detach_end;

   extern void datasystem_alloc();
   extern void datasystem_shift_right();
   extern void datasystem_shift_left();
   extern void datasystem_defrag();
   extern void datasystem_new();
   extern void datasystem_init(int dataline_max_size);
   extern void datasystem_set();

   extern void datasystem_verify(Datasystem * _datasystem);
   extern void datasystem_print();
   extern void datasystem_realloc();
# endif
